#!/usr/bin/env python
# -*- coding: utf-8 -*-


from gimpfu import *

"""
###################################################################
# BA_Conbagui_Welded_Text.py Tutorial Scripted #
https://gimplearn.net/viewtopic.php?f=3&t=767&p=7106&hilit=Welded+Text#p7106
###################################################################
This script follows Conbagui's Welded Text Tutorial
=== === === === === === === === === === === === === === === ===
=== === === === === === === === === === === === === === === ===
BA_Conbagui_Welded_Text instructions.txt
=== === === === === === === === === === === === === === === ===
This script needs both python LayerEffects
you can tell that you have the script by opening an image and right-clicking
on a layer in the layers box.  The the drop down menu appears an looking
at or very near the bottom you will see Layer Effects.   That is the python
version.  To find the .scm version - on the top menu click Script-Fu and
look for Layer Effects in the L's.   If you have them both you are ready.
=== === === === === === === === === === === === === === === ===
If not, download LayerFX.2.8.py and/or LayerFX.scm.
LayerFX.2.8.py needs to go into your Gimp plug-ins folder.
LayerFX.scm needs to go into your Gimp scripts folder.
When they have been placed, restart Gimp and look again to verify!
The 2 different scripts do not interfere with each other.
=== === === === === === === === === === === === === === === ===
=== === === === === === === === === === === === === === === === 
In the zip file you should have 
Conbagui's Welded Text Tutorial.pdf which this script was based on.
If you enjoy learning new things in Gimp, I recommend you follow 
his tutorials, there is always something new to learn!  Thank you for 
another excellent tutorial Conbagui!
=== === === === === === === === === === === === === === === ===
Also, from his tutorial you should have received these pattern files :
Lava.jpg
metal grid-1.png
metal grit-1.pat
Metal with holes.pat
Move these 4 pattern files into your Gimp patterns folder.
=== === === === === === === === === === === === === === === ===
And he also includes some Spark brushes which should be moved 
into your Gimp brushes folder.
Color spark 1.gbr
Color spark 2.gbr
Color spark 3.gbr
Color spark 4.gbr
=== === === === === === === === === === === === === === === ===
And lastly,  This instruction sheet
BA_Conbagui_Welded_Text instructions.txt
And the python script
BA_Conbagui_Welded_Text.py
which should be moved into your Gimp plug-ins directory.
=== === === === === === === === === === === === === === === ===
If not, download LayerFX.2.8.py and/or LayerFX.scm.
LayerFX.2.8.py needs to go into your Gimp plug-ins folder.
LayerFX.scm needs to go into your Gimp scripts folder.
When they have been placed, restart Gimp and look again to verify!
The 2 different scripts do not interfere with each other.
=== === === === === === === === === === === === === === === ===
Open a new file with the exact width of 1600 and the exact height of 900
Put some text on a layer, then when done, make sure the layer is at the 
top of the layer stack and that it is active (when active it will have a white
box border around the picture of the layer in the layers area.
=== === === === === === === === === === === === === === === ===
After you have created your subject text then run the script.
=== === === === === === === === === === === === === === === ===
The outcome with this script is just 2 layers, the top has your processed
text layer, and the bottom is the generated background.   You can 
also replace the background at this time with an image of your choice.
=== === === === === === === === === === === === === === === ===
You can use the  'Curves' tool from the Colors menu at the top on either
or both of these layers.   I find that on the text layer, a leaning to the right 
S shape works nice to bring the colors out. You may have different tastes 
and there are other tools in the colors menu for you to bring out something 
you enjoy.   Brightness/Contrast is another tool I like on this one.
Desaturate follow with Colorize is another way, or just Colorize without
the desaturation. 
=== === === === === === === === === === === === === === === ===
The outcome with this script is just 2 layers, the top has your processed
text layer, and the bottom is the generated background.   You can 
also replace the background at this time with an image of your choice.
=== === === === === === === === === === === === === === === ===
=== === === === === === === === === === === === === === === ===
===========================================================================================================
...................................................... 
####################
# COPYRIGHT NOTICE #
###############################################################################
# You should have received a copy of the GNU General Public License       #
# along with this program if not, you can view the GNU General Public     #
# License version 3 at the web site http://www.gnu.org/licenses/gpl-3.0.html  #
# Alternatively you can write to the Free Software Foundation, Inc., 675 Mass #
# Ave, Cambridge, MA 02139, USA.                          #
###############################################################################
"""


def BA_Conbagui_Welded_Text_new(text, margin, font,font_size, direction, just, letter_spacing, line_spacing, amplitude, patternbg, mergelayers): 
	gimp.set_foreground(0,0,0)
	
	# set background color
	gimp.set_background(255,255,255)

	# create image: width, height, type
	image = gimp.Image(font_size, font_size, RGB)

	# create layer with text and add it to the image: image, drawable, x, y, text, border, antialias, size, size_type, fontname
	text_layer = pdb.gimp_text_fontname(image, None, 0, 0, text, 0, 1, font_size, PIXELS, font)
	text_layer.name = ('text_layer')
	# justification:
	pdb.gimp_text_layer_set_base_direction (text_layer, direction)
	pdb.gimp_text_layer_set_justification (text_layer, just)
	pdb.gimp_text_layer_set_letter_spacing(text_layer, letter_spacing)
	pdb.gimp_text_layer_set_line_spacing(text_layer, line_spacing)

	pdb.gimp_image_resize_to_layers(image)

	wi = pdb.gimp_image_width(image)
	hi = pdb.gimp_image_height(image)
	
	new_width = wi + 2*margin
	new_height = hi + 2*margin
	
	wh = pdb.gimp_drawable_width(text_layer)
	hh = pdb.gimp_drawable_height(text_layer)
	centerx=wi/2
	centery=hi/2
	adw=wh/2
	adh=hh/2
	sw=centerx - adw
	sh=centery - adh		
	pdb.gimp_layer_set_offsets(text_layer, sw, sh)
	pdb.gimp_image_resize(image,new_width,new_height,margin, margin)
	pdb.gimp_layer_resize_to_image_size(text_layer)
	    
	# create layer: image, width, height, type, name, opacity, mode
	layer = gimp.Layer(image, "background", image.width, image.height, RGBA_IMAGE, 100, 0)

	# append layer to the image
	image.add_layer(layer, 1)
	layer.name=('Background')
	# fill layer with color
	pdb.gimp_context_set_pattern(patternbg)
	pdb.gimp_drawable_fill(layer,4)
	gimp.Display(image)


	####### Step2 duplicate, add mode and merge into background layer
	layer = pdb.gimp_image_get_active_layer(image)
	duplayer = pdb.gimp_layer_copy(layer,1)
	pdb.gimp_image_add_layer(image,duplayer,0)
	duplayer.name=('background copy')
	duplayer.mode=LAYER_MODE_MULTIPLY_LEGACY
	duplayer1 = pdb.gimp_layer_copy(layer,1)
	pdb.gimp_image_add_layer(image,duplayer1,1)
	duplayer1.name=('background1 copy')
    #background = pdb.gimp_image_flatten(image)
	background = pdb.gimp_image_merge_down(image, duplayer, 0)


	pdb.gimp_context_set_foreground('#2c2323')
	pdb.gimp_image_select_item(image,0,text_layer)
	pdb.gimp_edit_fill(text_layer,0)
	text_layercopy = pdb.gimp_layer_copy(text_layer,1)
	pdb.gimp_image_add_layer(image,text_layercopy,0)
	text_layercopy.name=('text_layercopy')
	pdb.gimp_selection_grow(image,2)
	pdb.gimp_edit_fill(text_layercopy,0)
	pdb.gimp_selection_none(image)
	pdb.gimp_item_set_visible(text_layercopy,False)
	
	black='#000000'  

	pdb.python_layerfx_drop_shadow(image,text_layer,black,75.0,0,0,2,0,7,120,9,1,0)
	#pdb.script_fu_layerfx_drop_shadow(image,text_layer,black,75.0,0,0,2,0,7,120,9,1,0)
	textdropshadow=pdb.gimp_image_get_active_layer(image)
	pdb.gimp_item_set_visible(textdropshadow,True)

	pdb.python_layer_fx_inner_glow(image,text_layer,'#183755',75.0,0,0,5,0,0,6,1)
	#pdb.script_fu_layerfx_inner_glow(image,text_layer,'#183755',75.0,0,0,5,0,0,6,1)
	text_layer = pdb.gimp_image_get_active_layer(image)

###################################################################################################
	style=1
	depth=65 
	direction=0 
	size=7 
	soften=1
	angle=50
	altitude=58
	gloss_contour=0
	highlight_color='#99d2fb'
	highlight_mode=LAYER_MODE_OVERLAY_LEGACY
	highlight_opacity=80.0
	shadow_color='#000000'
	shadow_mode=LAYER_MODE_MULTIPLY_LEGACY
	shadow_opacity=25.0
	surface_contour=0
	use_texture=1
	pattern=patternbg
	scale=50.0
	tex_depth=100.0
	invert=0
	merge=1
	pdb.python_layer_fx_bevel_emboss(image,text_layer,style,depth,direction,size,soften,angle,altitude,gloss_contour,highlight_color,highlight_mode,highlight_opacity,shadow_color,shadow_mode,shadow_opacity,surface_contour,use_texture,pattern,scale,tex_depth,invert,merge)
#####################################################################################################	
	
	text_layer = pdb.gimp_image_get_active_layer(image)

	highlight_opacity=45.0
	highlight_color='#ffffff'
	shadow_opacity=35.0
	angle=55
	altitude=30

	pdb.python_layer_fx_bevel_emboss(image,text_layer,style,depth,direction,size,soften,angle,altitude,gloss_contour,highlight_color,highlight_mode,highlight_opacity,shadow_color,shadow_mode,shadow_opacity,surface_contour,use_texture,pattern,scale,tex_depth,invert,merge)
#####################################################################################################	

	text_layer = pdb.gimp_image_get_active_layer(image)

	#pattern='Lava.jpg'
	opacity=100.0
	mode=LAYER_MODE_DIFFERENCE_LEGACY
	scale=20.0 
	interpolation=0
	merge=True
	pdb.python_layer_fx_pattern_overlay(image,text_layer,'Lava.jpg',opacity,mode,scale,interpolation,merge)

###########################################################################################################	
	text_layercopy = pdb.gimp_image_get_active_layer(image)   #????

	pdb.plug_in_waves(image,text_layercopy,amplitude,76.0,50.0,0,1)

	text_layertemp = pdb.gimp_layer_copy(text_layercopy,1)
	pdb.gimp_image_add_layer(image,text_layertemp,1)
	text_layertemp.name=('text_layerTemp')
	pdb.gimp_item_set_visible(text_layertemp,True)   
#########################################################################################################################################################################
	color='#000000'
	opacity=55.0
	contour=0
	noise=0.0
	mode=2 # gives Muliply Mode
	source=1
	choke=0
	size=6
	offset_angle=-77.0
	offset_distance=5.0
	merge=1 


	pdb.python_layerfx_inner_shadow(image,text_layercopy,color,opacity,contour,noise,mode,source,choke,size,offset_angle,offset_distance,merge)
	#pdb.script_fu_layerfx_inner_shadow(image,text_layercopy,color,opacity,contour,noise,mode,source,choke,size,offset_angle,offset_distance,merge)
###########################################################################################################################################################################	
	text_layercopy = pdb.gimp_image_get_active_layer(image)
	text_layercopy1 = pdb.gimp_image_get_active_layer(image)

	foreground='#33303a'
	pdb.gimp_image_select_item(image,0,text_layercopy1)
	pdb.gimp_selection_shrink(image,3)
	pdb.gimp_context_set_foreground(foreground)    
	pdb.gimp_edit_fill(text_layercopy1,0)        
	pdb.gimp_selection_none(image)

	style=1
	depth=65 
	direction=0 
	size=10 
	soften=1
	angle=55.0
	altitude=58.0
	gloss_contour=0
	highlight_color='#ffffff'  #should be black99d2fb
	highlight_mode=LAYER_MODE_OVERLAY_LEGACY
	highlight_opacity=75.0
	shadow_color='#99d2fb'
	shadow_mode=LAYER_MODE_OVERLAY_LEGACY
	shadow_opacity=80.0
	surface_contour=0
	use_texture=1
	pattern='Metal Grit-1'
	scale=100.0
	tex_depth=10.0
	invert=0
	merge=0

	text_layercopy1.mode=LAYER_MODE_SCREEN_LEGACY
	pdb.python_layer_fx_bevel_emboss(image,text_layercopy1,style,depth,direction,size,soften,angle,altitude,gloss_contour,highlight_color,highlight_mode,highlight_opacity,shadow_color,shadow_mode,shadow_opacity,surface_contour,use_texture,pattern,scale,tex_depth,invert,merge)

###############################################################################################	
	wrkimg=gimp.image_list()[0]
	wrklay=wrkimg.layers[1]
	wrklay.mode=LAYER_MODE_SCREEN_LEGACY

	text_layercopytemp1=pdb.gimp_layer_copy(text_layercopy1,1)
	pdb.gimp_image_add_layer(image,text_layercopytemp1,2) 
	text_layercopytemp1.name=('text_layerTemp for outerglow')
	

################################################################################################
	color='#d88511'
	#color=(216,133,17,1)
	opacity=100
	contour=0
	noise=0
	mode=16 #6 gives dodge-mode ???
	spread=20
	size=15
	knockout=1
	merge=0

	textouterglow = pdb.python_layerfx_outer_glow(image,text_layercopytemp1,color,opacity,contour,noise,mode,spread,size,knockout,merge)
	#pdb.script_fu_layerfx_outer_glow(image,text_layercopytemp1,color,opacity,contour,noise,mode,spread,size,knockout,merge)

#######################################################################################################
	
	textouterglow = pdb.gimp_image_get_active_layer(image)
	textouterglow.name='text1-outerglow'
	#pattern='Lava.jpg'
	opacity=100.0
	mode=LAYER_MODE_NORMAL_LEGACY
	scale=35.0 
	interpolation=0
	merge=False

	pdb.python_layer_fx_pattern_overlay(image,textouterglow,'Lava.jpg',opacity,mode,scale,interpolation,merge)

###############################################################################################################################	
	pdb.gimp_layer_resize_to_image_size(layer)
	textouterglow1 = pdb.gimp_image_get_active_layer(image)
	imglist=gimp.image_list()[0]
	wrklay=imglist.layers[1]
	wrklay.mode=LAYER_MODE_DODGE_LEGACY #16
	re=imglist.layers[0]
	pdb.gimp_image_remove_layer(image,re)
	#pdb.gimp_layer_set_visible(layer,False)
	pdb.gimp_layer_set_visible(background,True)
	if mergelayers:
		image.merge_visible_layers(CLIP_TO_IMAGE)
	

	#pdb.gimp_context_pop(image)
	pdb.gimp_displays_flush

	return()
register(
    "BA_Conbagui_Welded_Text_new",    
    "Script Based On Conbagui's Welded_Text_2",   
    "Requirments show at top",
    "animicule@gimpchat.com", 
    "Brian Andersen/MrQ", 
    "2017/2020",
    "BA Welded Text 2", 
    "", 
   [
		(PF_TEXT, 	"text", ("Text:"), "GIMP\nCHAT"),
		(PF_SPINNER, "margin", "Add border (px):", 50, (0, 500, 1)),
		(PF_FONT, "font", "Font:", "Arial"),
		(PF_INT, "font_size", "Font size (px):", 150),		
		(PF_OPTION,  "Direction", "Direction:", 0, ["From left to right",  "From right to left", "Vertical, right to left (mixed orientation)", "Vertical, right to left (upright orientation)", "Vertical, left to right (mixed orientation)", "Vertical, left to right (upright orientation)"]),
		(PF_OPTION, "just", "Justify:", 2, ["LEFT","RIGHT","CENTER","FILL"]),
		(PF_SPINNER, "letter_spacing", "Letter Spacing:", 0, (-100, 100, 1, 5, 0, 0)),
		(PF_SPINNER, "line_spacing", "Line Spacing:", 0, ( -100, 100, 1, 5, 0, 0)),
		(PF_SPINNER, "amplitude", "Amplitude of the Waves:", 5, (0, 15, 1)),
		(PF_PATTERN, "pattern", "Back pattern", "Metal Grit-1"),
		(PF_BOOL,  "mergelayers", "Merge layers?", False),
    ], 
    [],
    BA_Conbagui_Welded_Text_new,
    menu="<Image>/File/Create/Logos",
    )

main()
